package com.lantone.external.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lantone.common.util.StringUtil;
import com.lantone.external.entity.VLtDoctorAdvice;
import com.lantone.external.service.impl.VLtDoctorAdviceServiceImpl;
import com.lantone.external.vo.DataViewVO;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class VLtDoctorAdviceFacade extends VLtDoctorAdviceServiceImpl {

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public List<VLtDoctorAdvice> getDoctorAdviceData(DataViewVO dataViewVO){
        try{
            QueryWrapper hisQueryWrapper=queryWrapper(dataViewVO);
            List<VLtDoctorAdvice> list=this.baseMapper.selectList(hisQueryWrapper);
            return list;
        }catch (Exception e){
            log.error(e.getMessage());
            return null;
        }
    }

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    private QueryWrapper queryWrapper(DataViewVO dataViewVO){
        //拼接HIS查询条件
        QueryWrapper queryWrapper=new QueryWrapper<VLtDoctorAdvice>();
        if(StringUtil.isNotEmpty(dataViewVO.getDoctorAdviceId())){
            queryWrapper.eq("DOCTOR_ADVICE_ID", dataViewVO.getDoctorAdviceId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            queryWrapper.eq("HOSPITAL_ID", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getBehospitalCode())){
            queryWrapper.eq("BEHOSPITAL_CODE", dataViewVO.getBehospitalCode());
        }
        return queryWrapper;
    }

}
