package com.lantone.external.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lantone.common.util.StringUtil;
import com.lantone.external.entity.VLtHomeDiagnoseInfo;
import com.lantone.external.service.impl.VLtHomeDiagnoseInfoServiceImpl;
import com.lantone.external.vo.DataViewVO;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class VLtHomeDiagnoseInfoFacade extends VLtHomeDiagnoseInfoServiceImpl {

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public List<VLtHomeDiagnoseInfo> getHomeDiagnoseData(DataViewVO dataViewVO){
        try{
            QueryWrapper hisQueryWrapper=queryWrapper(dataViewVO);
            List<VLtHomeDiagnoseInfo> hisHomeDiagnoseList=this.baseMapper.selectList(hisQueryWrapper);
            return hisHomeDiagnoseList;
        }catch (Exception e){
            log.error(e.getMessage(),new Throwable());
            return null;
        }
    }

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    private QueryWrapper queryWrapper(DataViewVO dataViewVO){
        //拼接HIS查询条件
        QueryWrapper queryWrapper=new QueryWrapper<VLtHomeDiagnoseInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            queryWrapper.eq("HOME_PAGE_ID", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            queryWrapper.eq("HOSPITAL_ID", dataViewVO.getHospitalId());
        }
        return queryWrapper;
    }

    /*private UpdateWrapper updateWrapper(DataViewVO dataViewVO){
        UpdateWrapper updateWrapper=new UpdateWrapper<HomeDiagnoseInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            updateWrapper.eq("home_page_id", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            updateWrapper.eq("hospital_id", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getDiagnoseOrderNo())){
            updateWrapper.eq("diagnose_order_no", dataViewVO.getDiagnoseOrderNo());
        }
        return updateWrapper;
    }*/
}
