package com.lantone.external.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lantone.common.util.StringUtil;
import com.lantone.external.entity.VLtHomeOperationInfo;
import com.lantone.external.service.impl.VLtHomeOperationInfoServiceImpl;
import com.lantone.external.vo.DataViewVO;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class VLtHomeOperationInfoFacade extends VLtHomeOperationInfoServiceImpl {

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public List<VLtHomeOperationInfo> getHomeOperationData(DataViewVO dataViewVO){
        try{
            QueryWrapper hisQueryWrapper=queryWrapper(dataViewVO);
            List<VLtHomeOperationInfo> hisHomeOperationList=this.baseMapper.selectList(hisQueryWrapper);
            return hisHomeOperationList;
        }catch (Exception e){
            log.error("病案首页手术情况操作失败！"+e.getMessage(),new Throwable());
            return null;
        }
    }

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    private QueryWrapper queryWrapper(DataViewVO dataViewVO){
        //拼接HIS查询条件
        QueryWrapper queryWrapper=new QueryWrapper<VLtHomeOperationInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            queryWrapper.eq("HOME_PAGE_ID", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            queryWrapper.eq("HOSPITAL_ID", dataViewVO.getHospitalId());
        }
        return queryWrapper;
    }

}
