package com.lantone.external.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lantone.common.util.StringUtil;
import com.lantone.external.entity.VLtMedicalRecord;
import com.lantone.external.entity.VLtMedicalRecordContent;
import com.lantone.external.service.impl.VLtMedicalRecordContentServiceImpl;
import com.lantone.external.vo.DataViewVO;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class VLtMedicalRecordContentFacade extends VLtMedicalRecordContentServiceImpl {

    public List<VLtMedicalRecordContent> getHisMedicalRecordContentData(DataViewVO dataViewVO) {
        List<VLtMedicalRecordContent> VLtMedicalRecordContent = this.baseMapper.selectList(queryWrapper(dataViewVO));
        return VLtMedicalRecordContent;
    }

    public QueryWrapper queryWrapper(DataViewVO dataViewVO){
        //拼接朗通查询条件
        QueryWrapper queryWrapper=new QueryWrapper<VLtMedicalRecord>();
        if(StringUtil.isNotEmpty(dataViewVO.getRecId())){
            queryWrapper.eq("REC_ID", dataViewVO.getRecId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            queryWrapper.eq("HOSPITAL_ID", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getBehospitalCode())){
            queryWrapper.eq("BEHOSPITAL_CODE", dataViewVO.getBehospitalCode());
        }
        return queryWrapper;
    }

}
