package com.lantone.external.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.lantone.common.enums.IsDeleteEnum;
import com.lantone.common.util.ListUtil;
import com.lantone.common.util.StringUtil;
import com.lantone.external.dto.RespDTO;
import com.lantone.external.entity.VLtDoctorAdvice;
import com.lantone.external.vo.DataViewVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Component
@Slf4j
public class ViewDoctorAdviceFacade {

    @Autowired
    private VLtDoctorAdviceFacade hisDoctorAdviceFacade;

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public RespDTO getDoctorAdviceData(DataViewVO dataViewVO){
        try{
            if(StringUtil.isEmpty(dataViewVO.getBehospitalCode())){
                return RespDTO.onError("住院医嘱病历号为空！！");
            }
            //从his视图中获取数据
            List<VLtDoctorAdvice> list=hisDoctorAdviceFacade.getDoctorAdviceData(dataViewVO);
            if(ListUtil.isNotEmpty(list)){
                list.stream().forEach(s->{
                    /*DoctorAdvice vo=new DoctorAdvice();
                    BeanUtils.copyProperties(s,vo);
                    DoctorAdvice doctorAdvice=this.getOne(queryWrapper(vo));
                    //获取到对应数据，存到我方数据库中
                    if(doctorAdvice!=null){
                        //更新数据
                        vo.setIsDeleted(IsDeleteEnum.N.getKey());
                        vo.setGmtModified(new Date());
                        this.update(vo,updateWrapper(vo));
                    }else{
                        //新增数据
                        vo.setGmtCreate(new Date());
                        this.save(vo);
                    }*/
                });
                return RespDTO.onSuc("住院医嘱操作成功！");
            }else{
                return RespDTO.onSuc("住院医嘱操作取消，未获取到数据！");
            }

        }catch (Exception e){
            log.error("住院医嘱操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("住院医嘱操作失败！"+e.getMessage());
        }
    }

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    /*private QueryWrapper queryWrapper(DoctorAdvice doctorAdvice){
        //拼接朗通查询条件
        QueryWrapper queryWrapper=new QueryWrapper<DoctorAdvice>();
        if(StringUtil.isNotEmpty(doctorAdvice.getDoctorAdviceId())){
            queryWrapper.eq("doctor_advice_id", doctorAdvice.getDoctorAdviceId());
        }
        if(doctorAdvice.getHospitalId()!=null && doctorAdvice.getHospitalId()!=0L){
            queryWrapper.eq("hospital_id", doctorAdvice.getHospitalId());
        }
        if(StringUtil.isNotEmpty(doctorAdvice.getBehospitalCode())){
            queryWrapper.eq("behospital_code", doctorAdvice.getBehospitalCode());
        }
        return queryWrapper;
    }

    private UpdateWrapper updateWrapper(DoctorAdvice doctorAdvice){
        UpdateWrapper updateWrapper=new UpdateWrapper<DoctorAdvice>();
        if(StringUtil.isNotEmpty(doctorAdvice.getDoctorAdviceId())){
            updateWrapper.eq("doctor_advice_id", doctorAdvice.getDoctorAdviceId());
        }
        if(doctorAdvice.getHospitalId()!=null && doctorAdvice.getHospitalId()!=0L){
            updateWrapper.eq("hospital_id", doctorAdvice.getHospitalId());
        }
        if(StringUtil.isNotEmpty(doctorAdvice.getBehospitalCode())){
            updateWrapper.eq("behospital_code", doctorAdvice.getBehospitalCode());
        }
        return updateWrapper;
    }*/
}
