package com.lantone.external.facade;

import com.lantone.common.util.StringUtil;
import com.lantone.external.dto.RespDTO;
import com.lantone.external.entity.VLtHomeDiagnoseInfo;
import com.lantone.external.vo.DataViewVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Component
@Slf4j
public class ViewHomeDiagnoseInfoFacade{

    @Autowired
    private VLtHomeDiagnoseInfoFacade hisHomeDiagnoseInfoFacade;

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public RespDTO getHomeDiagnoseData(DataViewVO dataViewVO){
        try{
            if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
                return RespDTO.onError("病案首页ID为空！！");
            }else if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
                return RespDTO.onError("初始医院ID为空！！");
            }else if(StringUtil.isNotEmpty(dataViewVO.getBehospitalCode())){
                return RespDTO.onError("病历号为空！！");
            }

            List<VLtHomeDiagnoseInfo> hisHomeDiagnoseList=hisHomeDiagnoseInfoFacade.getHomeDiagnoseData(dataViewVO);
            /*if(ListUtil.isNotEmpty(hisHomeDiagnoseList)){
                for (VLtHomeDiagnoseInfo hisHomeDiagnose:hisHomeDiagnoseList) {
                    HomeDiagnoseInfo vo=new HomeDiagnoseInfo();
                    BeanUtils.copyProperties(hisHomeDiagnose,vo);

                    HomeDiagnoseInfo homeDiagnoseInfo=this.getOne(queryWrapper(dataViewVO));
                    //获取到对应数据，存到我方数据库中
                    if(homeDiagnoseInfo!=null){
                        //更新数据
                        vo.setIsDeleted(IsDeleteEnum.N.getKey());
                        vo.setGmtModified(new Date());
                        this.update(vo,updateWrapper(dataViewVO));
                    }else{
                        //新增数据
                        vo.setGmtCreate(new Date());
                        this.save(vo);
                    }
                }
            }*/
            return RespDTO.onSuc("操作成功！");
        }catch (Exception e){
            log.error("病案首页出院诊断操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("操作失败！");
        }
    }

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    /*public QueryWrapper queryWrapper(DataViewVO dataViewVO){
        //拼接朗通查询条件
        QueryWrapper queryWrapper=new QueryWrapper<HomeDiagnoseInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            queryWrapper.eq("home_page_id", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            queryWrapper.eq("hospital_id", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getDiagnoseOrderNo())){
            queryWrapper.eq("diagnose_order_no", dataViewVO.getDiagnoseOrderNo());
        }
        return queryWrapper;
    }

    public UpdateWrapper updateWrapper(DataViewVO dataViewVO){
        UpdateWrapper updateWrapper=new UpdateWrapper<HomeDiagnoseInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            updateWrapper.eq("home_page_id", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            updateWrapper.eq("hospital_id", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getDiagnoseOrderNo())){
            updateWrapper.eq("diagnose_order_no", dataViewVO.getDiagnoseOrderNo());
        }
        return updateWrapper;
    }*/
}
