package com.lantone.external.facade;

import com.lantone.common.util.ListUtil;
import com.lantone.external.dto.RespDTO;
import com.lantone.external.entity.VLtHomeOperationInfo;
import com.lantone.external.vo.DataViewVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Slf4j
public class ViewHomeOperationFacade {
    @Autowired
    private VLtHomeOperationInfoFacade hisHomeOperationInfoFacade;

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public RespDTO getHomeOperationData(DataViewVO dataViewVO){
        try{
            List<VLtHomeOperationInfo> hisHomeOperationList=hisHomeOperationInfoFacade.getHomeOperationData(dataViewVO);
            if(ListUtil.isNotEmpty(hisHomeOperationList)){
                /*for (VLtHomeOperationInfo hisHomeOperation:hisHomeOperationList) {
                    HomeOperationInfo homeOperationInfo=this.getOne(queryWrapper(dataViewVO));
                    HomeOperationInfo vo=new HomeOperationInfo();
                    BeanUtils.copyProperties(hisHomeOperation,vo);
                    //获取到对应数据，存到我方数据库中
                    if(homeOperationInfo!=null){
                        //更新数据
                        vo.setIsDeleted(IsDeleteEnum.N.getKey());
                        vo.setGmtModified(new Date());
                        this.update(vo,updateWrapper(dataViewVO));
                    }else{
                        //新增数据
                        vo.setGmtCreate(new Date());
                        this.save(vo);
                    }
                }*/
                return RespDTO.onSuc("病案首页手术情况操作成功！");
            }else{
                return RespDTO.onSuc("病案首页手术情况操作取消，未获取到数据！");
            }
        }catch (Exception e){
            log.error("病案首页手术情况操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("病案首页手术情况操作失败！"+e.getMessage());
        }
    }

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    /*private QueryWrapper queryWrapper(DataViewVO dataViewVO){
        //拼接朗通查询条件
        QueryWrapper queryWrapper=new QueryWrapper<HomeOperationInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            queryWrapper.eq("home_page_id", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            queryWrapper.eq("hospital_id", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getOperationOrderNo())){
            queryWrapper.eq("operation_order_no", dataViewVO.getOperationOrderNo());
        }
        return queryWrapper;
    }

    private UpdateWrapper updateWrapper(DataViewVO dataViewVO){
        UpdateWrapper updateWrapper=new UpdateWrapper<HomeOperationInfo>();
        if(StringUtil.isNotEmpty(dataViewVO.getHomePageId())){
            updateWrapper.eq("home_page_id", dataViewVO.getHomePageId());
        }
        if(dataViewVO.getHospitalId()!=null && dataViewVO.getHospitalId()!=0L){
            updateWrapper.eq("hospital_id", dataViewVO.getHospitalId());
        }
        if(StringUtil.isNotEmpty(dataViewVO.getOperationOrderNo())){
            updateWrapper.eq("operation_order_no", dataViewVO.getOperationOrderNo());
        }
        return updateWrapper;
    }*/
}
