package com.lantone.external.facade;

import com.lantone.common.util.ListUtil;
import com.lantone.common.util.StringUtil;
import com.lantone.external.dto.RespDTO;
import com.lantone.external.entity.VLtHomePage;
import com.lantone.external.vo.DataViewVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
@Slf4j
public class ViewHomePageFacade {
    @Autowired
    private VLtHomePageFacade hisHomePageFacade;
    @Autowired
    private ViewHomeDiagnoseInfoFacade viewHomeDiagnoseInfoFacade;
    @Autowired
    private ViewHomeOperationFacade viewHomeOperationFacade;
    /*@Autowired
    private BehospitalInfoFacade behospitalInfoFacade;*/

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public RespDTO getHomePageData(DataViewVO dataViewVO){
        try{
            if(StringUtil.isEmpty(dataViewVO.getBehospitalCode())){
                return RespDTO.onError("病案首页病历号为空！！");
            }
            VLtHomePage hisHomePage=hisHomePageFacade.getHomePageData(dataViewVO);
            if(hisHomePage!=null){
                //this.addHomePage(hisHomePage);
                //病案首页关联出院诊断及手术
                viewHomeDiagnoseInfoFacade.getHomeDiagnoseData(dataViewVO);
                viewHomeOperationFacade.getHomeOperationData(dataViewVO);

                return RespDTO.onSuc("病案首页操作成功！");
                /*
                //是否需要先评分，增加如下业务代码
                this.analyzeRun(hisHomePage);
                */
            }else{
                return RespDTO.onSuc("病案首页操作取消,未获取到数据！");
            }
        }catch (Exception e){
            log.error("病案首页操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("病案首页操作失败！");
        }
    }

    /*public RespDTO analyzeRun(VLtHomePage hisHomePage){
        AnalyzeRunVO analyzeRunVO = new AnalyzeRunVO();
        analyzeRunVO.setBehospitalCode(hisHomePage.getBehospitalCode());
        analyzeRunVO.setHospitalId(hisHomePage.getHospitalId());
        analyzeRunVO.setModeId(6L);
        AnalyzeRunDTO analyzeRunDTO =new AnalyzeRunDTO();
        Map<String, Object> map = new HashMap<String, Object>();
        if (analyzeRunDTO.getMsgDTOList().size() > 0) {
            map.put("analyze", analyzeRunDTO.getMsgDTOList());
        }
        return RespDTO.onSuc(map);
    }*/

    /**
     * @Description:补录数据时调用
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public RespDTO getHomePageSupplement(DataViewVO dataViewVO){
        try{
            if(StringUtil.isEmpty(dataViewVO.getBehospitalCode())){
                return RespDTO.onError("病案首页病历号为空！！");
            }
            List<VLtHomePage> list=hisHomePageFacade.getHomePageSupplement(dataViewVO);
            if(ListUtil.isNotEmpty(list)){
                list.stream().forEach(s->{
                    //this.addHomePage(s);
                    //病案首页关联出院诊断及手术
                    viewHomeDiagnoseInfoFacade.getHomeDiagnoseData(dataViewVO);
                    viewHomeOperationFacade.getHomeOperationData(dataViewVO);
                });
            }
            return RespDTO.onSuc("病案首页操作成功！");
        }catch (Exception e){
            log.error("病案首页操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("病案首页操作失败！");
        }
    }

    /*public void addHomePage(VLtHomePage hisHomePage){
        HomePage vo=new HomePage();
        BeanUtils.copyProperties(hisHomePage,vo);
        HomePage homePage=this.getOne(queryWrapper(hisHomePage));
        //获取到对应数据，存到我方数据库中
        if(homePage!=null){
            vo.setIsDeleted(IsDeleteEnum.N.getKey());
            vo.setGmtModified(new Date());
            //更新数据
            UpdateWrapper updateWrapper=updateWrapper(hisHomePage);
            this.update(vo,updateWrapper);
        }else{
            vo.setGmtCreate(new Date());
            //新增数据
            this.save(vo);
        }
    }*/

    /**
     * @Description:拼接查询条件
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    /*private QueryWrapper queryWrapper(VLtHomePage hisHomePage){
        //拼接朗通查询条件
        QueryWrapper queryWrapper=new QueryWrapper<HomePage>();
        if(StringUtil.isNotEmpty(hisHomePage.getHomePageId())){
            queryWrapper.eq("home_page_id", hisHomePage.getHomePageId());
        }
        if(hisHomePage.getHospitalId()!=null && hisHomePage.getHospitalId()!=0L){
            queryWrapper.eq("hospital_id", hisHomePage.getHospitalId());
        }
        if(StringUtil.isNotEmpty(hisHomePage.getBehospitalCode())){
            queryWrapper.eq("behospital_code", hisHomePage.getBehospitalCode());
        }
        return queryWrapper;
    }

    private UpdateWrapper updateWrapper(VLtHomePage hisHomePage){
        UpdateWrapper updateWrapper=new UpdateWrapper<HomePage>();
        if(StringUtil.isNotEmpty(hisHomePage.getHomePageId())){
            updateWrapper.eq("home_page_id", hisHomePage.getHomePageId());
        }
        if(hisHomePage.getHospitalId()!=null && hisHomePage.getHospitalId()!=0L){
            updateWrapper.eq("hospital_id", hisHomePage.getHospitalId());
        }
        if(StringUtil.isNotEmpty(hisHomePage.getBehospitalCode())){
            updateWrapper.eq("behospital_code", hisHomePage.getBehospitalCode());
        }
        return updateWrapper;
    }*/
}
