package com.lantone.external.facade;

import com.lantone.common.util.StringUtil;
import com.lantone.external.dto.RespDTO;
import com.lantone.external.entity.VLtMedicalRecord;
import com.lantone.external.vo.DataViewVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class ViewMRecordFacade {
    @Autowired
    private VLtMedicalRecordFacade hisMedicalRecordFacade;

    /*@Autowired
    private ModelHospitalFacade modelHospitalFacade;*/

    @Autowired
    private ViewMRecordContentFacade viewMRecordContentFacade;

    /**
     * @Description:根据接口中的参数，进行查询拉取数据到入院登记表
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    public RespDTO getMedicalRecordData(DataViewVO dataViewVO){
        try{
            if(StringUtil.isEmpty(dataViewVO.getBehospitalCode())){
                return RespDTO.onError("文书病历号为空！！");
            }else if(StringUtil.isEmpty(dataViewVO.getRecId())){
                return RespDTO.onError("文书病历序号为空！！");
            }else if(dataViewVO.getHospitalId()==null || dataViewVO.getHospitalId()==0L){
                return RespDTO.onError("初始医院ID为空！！");
            }
            VLtMedicalRecord VLtMedicalRecord =hisMedicalRecordFacade.getMedicalRecordData(dataViewVO);

            if(VLtMedicalRecord !=null){
                //this.addMrecord(VLtMedicalRecord);
                //viewMRecordContentFacade.addMrecordContent(VLtMedicalRecord);
                return RespDTO.onSuc("病历文书操作成功！");
                /*
                //是否需要先评分，增加如下业务代码
                this.analyzeRun(hisMedicalRecord);
                */
            }else{
                return RespDTO.onSuc("病历文书操作取消,未获取到数据！");
            }
        }catch (Exception e){
            log.error("病历文书操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("病历文书操作失败！");
        }
    }

    /*public RespDTO analyzeRun(VLtMedicalRecord VLtMedicalRecord){
        Long initModeId=initModeId(VLtMedicalRecord.getHospitalId(), VLtMedicalRecord.getRecTypeId());
        AnalyzeRunVO analyzeRunVO = new AnalyzeRunVO();
        analyzeRunVO.setBehospitalCode(VLtMedicalRecord.getBehospitalCode());
        analyzeRunVO.setHospitalId(VLtMedicalRecord.getHospitalId());
        analyzeRunVO.setModeId(initModeId);
        //AnalyzeRunDTO analyzeRunDTO = behospitalInfoFacade.analyzeRun(analyzeRunVO);
        AnalyzeRunDTO analyzeRunDTO =new AnalyzeRunDTO();
        Map<String, Object> map = new HashMap<String, Object>();
        if (analyzeRunDTO.getMsgDTOList().size() > 0) {
            map.put("analyze", analyzeRunDTO.getMsgDTOList());
        }
        return RespDTO.onSuc(map);
    }

    public RespDTO getMedicalRecordSupplement(DataViewVO dataViewVO){
        try{
            List<VLtMedicalRecord> VLtMedicalRecordList =hisMedicalRecordFacade.getMedicalRecordSupplement(dataViewVO);
            if(ListUtil.isNotEmpty(VLtMedicalRecordList)){
                for (VLtMedicalRecord VLtMedicalRecord : VLtMedicalRecordList) {
                    this.addMrecord(VLtMedicalRecord);
                    viewMRecordContentFacade.addMrecordContent(VLtMedicalRecord);
                }
                return RespDTO.onSuc("病历文书操作成功！");
            }else{
                return RespDTO.onSuc("病历文书操作取消,未获取到数据！");
            }
        }catch (Exception e){
            log.error("病历文书操作失败！"+e.getMessage(),new Throwable());
            return RespDTO.onError("病历文书操作失败！");
        }
    }

    public QueryWrapper queryWrapper(VLtMedicalRecord VLtMedicalRecord){
        //拼接朗通查询条件
        QueryWrapper queryWrapper=new QueryWrapper<MedicalRecord>();
        if(StringUtil.isNotEmpty(VLtMedicalRecord.getRecId())){
            queryWrapper.eq("rec_id", VLtMedicalRecord.getRecId());
        }
        if(VLtMedicalRecord.getHospitalId()!=null && VLtMedicalRecord.getHospitalId()!=0L){
            queryWrapper.eq("hospital_id", VLtMedicalRecord.getHospitalId());
        }
        if(StringUtil.isNotEmpty(VLtMedicalRecord.getBehospitalCode())){
            queryWrapper.eq("behospital_code", VLtMedicalRecord.getBehospitalCode());
        }
        return queryWrapper;
    }

    public UpdateWrapper updateWrapper(VLtMedicalRecord VLtMedicalRecord){
        UpdateWrapper updateWrapper=new UpdateWrapper<MedicalRecord>();
        if(StringUtil.isNotEmpty(VLtMedicalRecord.getRecId())){
            updateWrapper.eq("rec_id", VLtMedicalRecord.getRecId());
        }
        if(VLtMedicalRecord.getHospitalId()!=null && VLtMedicalRecord.getHospitalId()!=0L){
            updateWrapper.eq("hospital_id", VLtMedicalRecord.getHospitalId());
        }
        if(StringUtil.isNotEmpty(VLtMedicalRecord.getBehospitalCode())){
            updateWrapper.eq("behospital_code", VLtMedicalRecord.getBehospitalCode());
        }
        return updateWrapper;
    }

    public void addMrecord(VLtMedicalRecord VLtMedicalRecord){
        try{
            MedicalRecord medicalRecord=this.getOne(queryWrapper(VLtMedicalRecord));
            MedicalRecord vo=new MedicalRecord();
            BeanUtils.copyProperties(VLtMedicalRecord,vo);
            //初始化mode_id
            vo.setModeId(initModeId(VLtMedicalRecord.getHospitalId(), VLtMedicalRecord.getRecTypeId()));

            //获取到对应数据，存到我方数据库中
            if(medicalRecord!=null){
                vo.setGmtModified(new Date());
                vo.setIsDeleted(IsDeleteEnum.N.getKey());
                //更新数据
                this.update(vo,updateWrapper(VLtMedicalRecord));
            }else{
                //新增数据
                vo.setGmtCreate(new Date());
                this.save(vo);
            }
        }catch (Exception e){
            log.error("异步增加文书数据异常：：：："+e.getMessage(),new Throwable());
        }
    }

    *//**
     * 初始化模型ID
     *
     * @param hospitalId
     * @param recTypeId
     * @return
     *//*
    public Long initModeId(Long hospitalId, String recTypeId) {
        Long modeId = Long.valueOf("0");
        QueryWrapper<ModelHospital> wrapper = new QueryWrapper<>();
        wrapper.eq("hospital_id", hospitalId);
        //wrapper.eq("hospital_model_name", recTitle);
        wrapper.eq("remark", recTypeId);
        ModelHospital mode = modelHospitalFacade.getOne(wrapper, false);
        if (mode != null) {
            modeId = mode.getStandModelId();
        } else {
            modeId = Long.valueOf("0");
        }
        modeId=11L;
        return modeId;
    }*/
}
