package com.lantone.external.task;

import com.lantone.external.dto.RespDTO;
import com.lantone.external.facade.VLtDeptInfoFacade;
import com.lantone.external.facade.VLtDoctorInfoFacade;
import com.lantone.external.facade.VLtRecordTypeFacade;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
@Slf4j
public class DataViewTask {
    /*@Autowired
    RedisUtil redisUtil;*/

    private static final String DEPTS = "depts";
    private static final String DOCTORS = "doctors";
    private static final String RECORD_TYPE = "recordTypes";

    @Autowired
    private VLtDeptInfoFacade vLtDeptInfoFacade;

    @Autowired
    private VLtDoctorInfoFacade vLtDoctorInfoFacade;

    @Autowired
    private VLtRecordTypeFacade vLtRecordTypeFacade;

    /**
     * @Description:查询数据并存到缓存中
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    @Scheduled(cron = "0 25 17 * * ?")
    public void syncHisData() throws Exception{
        //将his数据存到缓存中
        vLtRecordTypeFacade.syncRecordType();
        vLtDeptInfoFacade.syncDeptInfo();
        vLtDoctorInfoFacade.syncDoctorInfo();
    }

    /**
     * @Description:
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    //@Scheduled(cron = "0 23 14 * * ?")
    public RespDTO initDoctorData(){
        try{
            //获取所有的key值
            //String values= redisUtil.get(DOCTORS);
            //根据key值，获取对应的数据
           /* List<BasDoctorInfo> list= JSON.parseArray(values,BasDoctorInfo.class);
            if(ListUtil.isNotEmpty(list)){
                aBasDoctorInfoFacade.execute(list);
            }*/
            return RespDTO.onSuc("定时拉取医生信息成功！！！");
        }catch (Exception e){
            return RespDTO.onError("定时拉取医生信息异常！！！"+e.getMessage());
        }
    }

    /**
     * @Description:
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    //@Scheduled(cron = "0 47 17 * * ?")
    public void initDeptData(){
        //获取所有的key值
        //String values= redisUtil.get(DEPTS);
        //根据key值，获取对应的数据
        /*List<BasDeptInfo> list= JSON.parseArray(values,BasDeptInfo.class);
        if(ListUtil.isNotEmpty(list)){
            aBasDeptInfoFacade.execute(list);
        }*/
    }

    /**
     * @Description:
     * @Author:liuqq
     * @time: ${DATE} ${TIME}
     **/
    //@Scheduled(cron = "0 48 17 * * ?")
    public void initRecordTypeData(){
        //获取所有的key值
        //String values= redisUtil.get(RECORD_TYPE);
        //根据key值，获取对应的数据
        /*List<MedRecordType> list= JSON.parseArray(values,MedRecordType.class);
        if(ListUtil.isNotEmpty(list)){
            aMedRecordTypeFacade.execute(list);
        }*/
    }

    public void initDoctors() throws Exception{
        //获取所有的key值
        //Set<String> keys= redisUtil.getKeyList(DEPTS+"**");
        //根据key值，获取对应的数据
        /*List<List<BasDoctorInfo>> list=redisUtil.multiGet(keys);
        if(ListUtil.isNotEmpty(list)){
            List<BasDoctorInfo> basDoctorInfoList= Lists.newArrayList();
            list.forEach(s->{
                s.forEach(l->{
                    //l.setDoctorId(l.getDoctorId()+ RandomUtil.randomNumber());
                    l.setDoctorId(l.getDoctorId()+ RandomUtil.randomNumbers(3));
                    l.setOccup(RandomUtil.randomNumbers(3));
                    l.setGmtCreate(new Date());
                    basDoctorInfoList.add(l);
                });
            });
            //剔除重复项，已最新入库时间为先，医生ID为唯一值
            basDoctorInfoList.sort(Comparator.comparing(BasDoctorInfo::getGmtCreate).reversed());
            basDoctorInfoList.stream().filter(i-> StringUtil.isNotBlank(i.getDoctorId())).findFirst();
            Map<String,BasDoctorInfo> doctorMap= new HashMap<>();
            basDoctorInfoList.stream().forEach(s->{
                if(!doctorMap.containsKey(s.getDoctorId())){
                    doctorMap.put(s.getDoctorId(),s);
                }
            });

            List<BasDoctorInfo> doctorInfoList=doctorMap.values().stream().collect(Collectors.toList());
            aBasDoctorInfoFacade.execute(doctorInfoList);

            //清除缓存中内容
            redisUtil.delete(keys);
        }*/
    }
}
