package com.lantone.external.web;

import com.lantone.external.dto.DataBalanceDTO;
import com.lantone.external.facade.DataBalanceFacade;
import com.lantone.external.vo.DataViewVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/balance/data")
@Api(value = "数据比对", tags = { "对接接口API-数据比对" })
public class DataBalanceController {

    @Autowired
    private DataBalanceFacade dataBalanceFacade;

    @ApiOperation(value = "数据比对-获取某个入院时间段内的病历数")
    @PostMapping("/getDataCount")
    public List<DataBalanceDTO> getDataCount(DataViewVO dataViewVO){
        return dataBalanceFacade.balanceData(dataViewVO);
    }
}
